<template>
  <CommandExecuteContext v-bind:commands="commandContext"></CommandExecuteContext>
</template>

<script>
  import UserCommands from "../../../commands/UserCommands"
  import CommandExecuteContext from '../../../commands/CommandExecuteContext'
  import LinkService from '@/domain/services/LinkService.js'
  import HelperUtil from "../../../utils/HelperUtil";

  export default {
    props: ['command'],

    components: {
      CommandExecuteContext,
    },

    data:function () {
      return {
        deleteList: this.command.target,

        //命令
        commandContext: {},

        confirmFlag: {
          confirm: false,
        },
      }
    },
    methods: {
      close(){
        this.command.done();
      },

      open() {
        let _this = this;
        _this.InfoTip.conformTip(_this, HelperUtil.getCheckStatusCodeObjectByCode(_this.successCode.DELETE_CONFIRM)
        ).then(() => {
          this.deleteLink();
        }).catch(()=>{
          this.command.done()
        });
      },

      //删除link
      deleteLink() {
        //调用函数
        console.log(JSON.stringify(this.deleteList));
        LinkService.batchLinkDelete(JSON.stringify(this.deleteList)).then(result => {
          //成功
          console.log("删除成功");
          this.InfoTip.successTip(this,HelperUtil.getStatusCodeObjectByCode(this.successCode.DELETE_CODE));
          this.close()
        }).catch(err => {
          //失败
          console.log("删除失败")
          this.InfoTip.errorTip(this,err);
          this.close()
        })
      }
    },
    watch: {
      commandContext (newVal, oldVal){
        let _this = this;
        if(_this.confirmFlag.confirm){
          this.open();
          this.confirmFlag.confirm = false
        }
        else{
          if(JSON.stringify(newVal) === '{}'){
            _this.close()
          }
        }
        deep: true
      },
    },

    created() {
      this.confirmUserCommand.execute();
    },

    computed: {
      confirmUserCommand(){
        this.confirmFlag.confirm = false;
        return UserCommands.confirmUserCommand(this.commandContext, this.confirmFlag)
      },
    },

  }
</script>
